diff --git a/hive.gemspec b/hive.gemspec
index d5be0ed2..5245e0ba 100644
--- a/hive.gemspec
+++ b/hive.gemspec
@@ -52,4 +52,5 @@ Gem::Specification.new do |spec|
   spec.add_dependency "lipgloss", "~> 0.2.2"
   spec.add_dependency "telegram-bot-ruby", "~> 2.7"
   spec.add_dependency "thor", "~> 1.3"
+  spec.add_dependency "unicode-display_width", "~> 3.2"
 end
diff --git a/lib/hive/tui/bubble_model.rb b/lib/hive/tui/bubble_model.rb
index d42249e3..491f5549 100644
--- a/lib/hive/tui/bubble_model.rb
+++ b/lib/hive/tui/bubble_model.rb
@@ -33,6 +33,7 @@ require "hive/tui/views/red_status_detail"
 require "hive/tui/views/help_overlay"
 require "hive/tui/views/filter_prompt"
 require "hive/tui/views/idea_preview"
+require "hive/tui/info_panel_content"
 require "hive/tui/views/new_idea_prompt"
 require "hive/tui/views/new_idea_project_picker"
 
@@ -147,6 +148,11 @@ module Hive
         # is plausibly a stalled compositor; two-in-a-row warrants a
         # flash so the operator knows paste is wedged.
         @clipboard_consecutive_timeouts = 0
+        # Monotonic request tokens for the info-panel background load.
+        # Each open increments; completions whose token no longer match
+        # the open panel are ignored so late reads cannot reopen stale
+        # content after the user closed or switched rows.
+        @idea_preview_token = 0
       end
 
       # Late binding so App.run_charm can wire the runner reference
@@ -1514,42 +1520,47 @@ module Hive
         [ flashed("editor command invalid: #{e.message}"), nil ]
       end
 
+      # Enter the full-screen info panel immediately in a loading state,
+      # then load InfoPanelContent off the render thread via a background
+      # Bubble Tea command (Proc → runner Thread). Token correlation
+      # discards completions that arrive after close/switch.
       def open_idea_preview(row)
         return [ flashed("no idea for #{row.slug}"), nil ] if row.folder.to_s.empty?
 
-        idea_path = File.join(row.folder, "idea.md")
-        return [ flashed("no idea.md for #{row.slug}"), nil ] unless File.exist?(idea_path)
-
-        data = idea_frontmatter(File.read(idea_path))
-        original_text = data["original_text"].to_s
-        if original_text.empty?
-          return [ flashed("idea has no original_text for #{row.slug}"), nil ]
-        end
-
-        capped_text = original_text[0, Hive::Tui::Model::NEW_IDEA_BUFFER_MAX_CHARS]
-        [
-          @hive_model.with(
-            mode: :idea_preview,
-            idea_preview_text: capped_text,
-            idea_preview_slug: row.slug
-          ),
-          nil
-        ]
-      rescue Errno::ENOENT, Errno::EACCES, Psych::Exception
-        [ flashed("could not read idea for #{row.slug}"), nil ]
+        @idea_preview_token += 1
+        token = @idea_preview_token
+        state = Hive::Tui::Model::IdeaPreviewState.new(
+          row: row,
+          token: token,
+          status: :loading
+        )
+        new_model = @hive_model.with(mode: :idea_preview, idea_preview_state: state)
+        cmd = idea_preview_load_command(row: row, token: token)
+        [ new_model, cmd ]
       end
 
-      def idea_frontmatter(contents)
-        match = contents.match(/\A---[ \t]*\r?\n(.*?)\r?\n---[ \t]*(?:\r?\n|\z)/m)
-        return {} unless match
-
-        parsed = YAML.safe_load(
-          match[1],
-          permitted_classes: [ Time, Date ],
-          permitted_symbols: [],
-          aliases: false
-        ) || {}
-        parsed.is_a?(Hash) ? parsed : {}
+      def idea_preview_load_command(row:, token:)
+        dispatch = @dispatch
+        lambda do
+          begin
+            content = Hive::Tui::InfoPanelContent.load(row)
+            dispatch.call(
+              Hive::Tui::Messages::IdeaPreviewLoaded.new(token: token, content: content)
+            )
+          rescue StandardError, SystemStackError => e
+            Hive::Tui::Debug.log(
+              "idea_preview",
+              "load failed slug=#{row.slug} token=#{token} err=#{e.class.name}: #{e.message}"
+            )
+            dispatch.call(
+              Hive::Tui::Messages::IdeaPreviewFailed.new(
+                token: token,
+                error: "#{e.class.name.split('::').last}: #{e.message}"
+              )
+            )
+          end
+          nil
+        end
       end
 
       def resolve_agent_label(row)
@@ -2884,9 +2895,14 @@ module Hive
         compose_two_pane_view(footer: prompt_footer(Views::FilterPrompt.render(@hive_model, width: usable), usable))
       end
 
+      # Full-screen info panel replaces the grid for the entire frame
+      # (not a bottom strip under the two-pane layout).
       def compose_idea_preview_view
-        usable = [ @hive_model.cols.to_i - 1, 1 ].max
-        compose_two_pane_view(footer: prompt_footer(Views::IdeaPreview.render(@hive_model, width: usable), usable))
+        Views::IdeaPreview.render(
+          @hive_model,
+          width: @hive_model.cols.to_i,
+          height: @hive_model.rows.to_i
+        )
       end
 
       # New-idea mode: same composition; footer = the inline prompt with
@@ -3001,23 +3017,45 @@ module Hive
 
       # Default footer — context-aware key hints + flash decay (the
       # status line). v1 had this in Views::Grid#status_line; lifted here
-      # so the panes stay layout-only. `usable_width` clamps the line
-      # so the fixed 75-char hint string doesn't overflow narrow
-      # terminals (e.g. cols=70 used to wrap onto a second visible row).
+      # so the panes stay layout-only. When the legend exceeds the usable
+      # width, wrap before `[?] help` so the help/info/quit group stays
+      # visible together instead of truncating the new `[i] info` binding.
       def default_footer(usable_width = nil)
         if @hive_model.flash_active?
           line = @hive_model.flash.to_s
           line = Views::Format.truncate(line, usable_width) if usable_width
           Hive::Tui::Styles::FLASH.render(line)
         else
-          line = footer_hint
-          line = Views::Format.truncate(line, usable_width) if usable_width
-          Hive::Tui::Styles::HINT.render(line)
+          wrap_footer_hint(footer_hint, usable_width)
+            .map { |line| Hive::Tui::Styles::HINT.render(line) }
+            .join("\n")
         end
       end
 
       def footer_hint
-        "[Tab] switch  [Enter] action  [n] new  [/] filter  [?] help  [q] quit"
+        "[Tab] switch  [Enter] action  [n] new  [/] filter  [?] help  [i] info  [q] quit"
+      end
+
+      # Deterministic legend wrap. Prefer a single line; when width is
+      # tight, put primary actions on line 1 and keep
+      # `[?] help  [i] info  [q] quit` intact on line 2.
+      def wrap_footer_hint(hint, usable_width)
+        text = hint.to_s
+        return [ text ] if usable_width.nil? || usable_width <= 0
+        return [ text ] if text.length <= usable_width
+
+        group = "[?] help  [i] info  [q] quit"
+        prefix = "[Tab] switch  [Enter] action  [n] new  [/] filter"
+        if group.length <= usable_width && prefix.length <= usable_width
+          return [ prefix, group ]
+        end
+
+        # Extremely narrow: hard-truncate each preferred segment so no
+        # footer row exceeds the usable width.
+        [
+          Views::Format.truncate(prefix, usable_width),
+          Views::Format.truncate(group, usable_width)
+        ]
       end
 
       # Compute pane widths and join horizontally. Left pane is clamped
diff --git a/lib/hive/tui/info_panel_content.rb b/lib/hive/tui/info_panel_content.rb
new file mode 100644
index 00000000..27236632
--- /dev/null
+++ b/lib/hive/tui/info_panel_content.rb
@@ -0,0 +1,94 @@
+require "hive/tui/log_tail"
+require "hive/tui/info_panel_content/artifact_reader"
+require "hive/tui/info_panel_content/stage_reader"
+
+module Hive
+  module Tui
+    # Read-only loader for the full-screen task info panel (`i` key).
+    # Centralizes filesystem reads and stage-specific content selection
+    # so BubbleModel never accumulates stage-file parsing rules.
+    #
+    # All methods are pure with respect to task state: they never mutate
+    # files, markers, or workflow state. Missing/unreadable optional
+    # fields degrade to availability markers rather than raising.
+    module InfoPanelContent
+      MARKDOWN_BYTE_CAP = 256 * 1024
+      EXECUTE_LOG_PATTERN = "execute-*.log"
+      EXECUTE_TAIL_LINES = 50
+      EXECUTE_BACKBUFFER_BYTES = LogTail::Tail::DEFAULT_BACKBUFFER_BYTES
+      UNAVAILABLE = "unavailable".freeze
+
+      # Immutable snapshot consumed by the info-panel view.
+      #
+      # `stage_extra_kind` is one of:
+      #   nil              — no stage-specific section (1-inbox, 5–9)
+      #   :brainstorm      — brainstorm.md body
+      #   :plan            — plan.md body
+      #   :execute_log     — trailing lines of newest execute-*.log
+      Content = Data.define(
+        :slug,
+        :stage,
+        :created_at,
+        :created_at_available,
+        :original_text,
+        :original_text_available,
+        :original_text_truncated,
+        :task_folder,
+        :latest_log_path,
+        :latest_log_available,
+        :stage_extra_kind,
+        :stage_extra_label,
+        :stage_extra_text,
+        :stage_extra_available,
+        :stage_extra_truncated
+      )
+
+      module_function
+
+      # Build a Content snapshot for `row`. Never raises for expected
+      # filesystem races or parse failures; those become unavailable
+      # fields. Unexpected programmer errors still propagate.
+      def load(row)
+        folder = absolute_folder(row)
+        slug = row.respond_to?(:slug) ? row.slug.to_s : ""
+        stage = row.respond_to?(:stage) ? row.stage.to_s : ""
+
+        created_at, created_ok, original_text, original_ok, original_trunc =
+          ArtifactReader.load_idea_fields(folder)
+
+        log_path, log_ok = StageReader.load_latest_log_path(folder)
+        extra_kind, extra_label, extra_text, extra_ok, extra_trunc =
+          StageReader.load_stage_extra(stage, folder)
+
+        Content.new(
+          slug: slug,
+          stage: stage,
+          created_at: created_at,
+          created_at_available: created_ok,
+          original_text: original_text,
+          original_text_available: original_ok,
+          original_text_truncated: original_trunc,
+          task_folder: folder,
+          latest_log_path: log_path,
+          latest_log_available: log_ok,
+          stage_extra_kind: extra_kind,
+          stage_extra_label: extra_label,
+          stage_extra_text: extra_text,
+          stage_extra_available: extra_ok,
+          stage_extra_truncated: extra_trunc
+        )
+      end
+
+      def absolute_folder(row)
+        raw = row.respond_to?(:folder) ? row.folder.to_s : ""
+        return "" if raw.empty?
+
+        File.expand_path(raw)
+      rescue ArgumentError
+        raw.to_s
+      end
+
+      private_class_method :absolute_folder
+    end
+  end
+end
diff --git a/lib/hive/tui/info_panel_content/artifact_reader.rb b/lib/hive/tui/info_panel_content/artifact_reader.rb
new file mode 100644
index 00000000..ef0df221
--- /dev/null
+++ b/lib/hive/tui/info_panel_content/artifact_reader.rb
@@ -0,0 +1,136 @@
+require "date"
+require "yaml"
+require "hive/tui/log_tail"
+
+module Hive
+  module Tui
+    module InfoPanelContent
+      # Bounded UTF-8 reads and idea.md frontmatter parsing for the info panel.
+      module ArtifactReader
+        module_function
+
+        def load_idea_fields(folder)
+          return [ nil, false, "", false, false ] if folder.empty?
+
+          idea_path = File.join(folder, "idea.md")
+          return [ nil, false, "", false, false ] unless File.file?(idea_path)
+
+          raw = read_bounded_bytes(idea_path, MARKDOWN_BYTE_CAP)
+          return [ nil, false, "", false, false ] if raw.nil?
+
+          file_truncated = file_exceeds_cap?(idea_path, MARKDOWN_BYTE_CAP)
+          data, frontmatter_truncated = idea_frontmatter(raw, truncated: file_truncated)
+          created_str = format_created_at(data["created_at"])
+          created_ok = !created_str.nil?
+
+          original = scrub_encoding(data["original_text"].to_s)
+          original_ok = !original.empty?
+          original, original_trunc = bound_text(original, MARKDOWN_BYTE_CAP)
+
+          [ created_str, created_ok, original, original_ok,
+            original_trunc || (original_ok && frontmatter_truncated) ]
+        rescue *LogTail::FILESYSTEM_RESCUE, Psych::Exception, ArgumentError
+          [ nil, false, "", false, false ]
+        end
+
+        def read_bounded_bytes(path, cap)
+          scrub_encoding(File.binread(path, cap))
+        rescue *LogTail::FILESYSTEM_RESCUE
+          nil
+        end
+
+        def file_exceeds_cap?(path, cap)
+          File.size(path) > cap
+        rescue *LogTail::FILESYSTEM_RESCUE
+          false
+        end
+
+        # Cap string by bytes on a clean character boundary. The returned
+        # flag tells the view to append the visible ellipsis marker.
+        def bound_text(text, cap)
+          raw = text.to_s
+          return [ raw, false ] if raw.bytesize <= cap
+
+          sliced = scrub_encoding(raw.byteslice(0, cap).to_s)
+          [ sliced, true ]
+        end
+
+        # Artifact files are UTF-8 even though bounded reads use binary mode.
+        # Retag bytes before scrubbing so valid multibyte text stays lossless.
+        def scrub_encoding(text)
+          utf8 = text.to_s.dup.force_encoding(Encoding::UTF_8)
+          utf8.valid_encoding? ? utf8 : utf8.scrub("?")
+        rescue EncodingError
+          text.to_s.b.force_encoding(Encoding::UTF_8).scrub("?")
+        end
+
+        def idea_frontmatter(contents, truncated: false)
+          text = scrub_encoding(contents.to_s)
+          parsed = parse_frontmatter(text)
+          return [ parsed, false ] unless parsed.nil?
+          return [ {}, false ] unless truncated && text.match?(/\A---[ \t]*\r?\n/)
+
+          truncated_frontmatter_candidates(text).each do |candidate|
+            parsed = parse_frontmatter(candidate)
+            return [ parsed, true ] unless parsed.nil?
+          end
+
+          [ {}, false ]
+        end
+
+        def parse_frontmatter(text)
+          match = text.match(/\A---[ \t]*\r?\n(.*?)\r?\n---[ \t]*(?:\r?\n|\z)/m)
+          return nil unless match
+
+          parsed = YAML.safe_load(
+            match[1],
+            permitted_classes: [ Time, Date ],
+            permitted_symbols: [],
+            aliases: false
+          ) || {}
+          parsed.is_a?(Hash) ? parsed : {}
+        rescue Psych::Exception, SystemStackError
+          nil
+        end
+
+        def truncated_frontmatter_candidates(text)
+          candidates = [ close_truncated_frontmatter(text) ]
+          quote = text.match(/^original_text:[ \t]*(?<quote>["'])/)&.[](:quote)
+          return candidates if quote.nil?
+
+          if quote == "'"
+            candidates << close_truncated_frontmatter("#{text}'")
+            candidates << close_truncated_frontmatter("#{text}''")
+          else
+            candidates << close_truncated_frontmatter(%(#{text}"))
+            last_escape = text.rindex("\\")
+            candidates << close_truncated_frontmatter(%(#{text[0...last_escape]}")) if last_escape
+          end
+          candidates.uniq
+        end
+
+        def close_truncated_frontmatter(text)
+          text.end_with?("\n") ? "#{text}---\n" : "#{text}\n---\n"
+        end
+
+        def format_created_at(value)
+          return nil if value.nil?
+
+          case value
+          when Time
+            value.utc.iso8601
+          when Date
+            value.to_time.utc.iso8601
+          else
+            text = value.to_s.strip
+            text.empty? ? nil : text
+          end
+        end
+
+        private_class_method :idea_frontmatter, :parse_frontmatter,
+                             :truncated_frontmatter_candidates,
+                             :close_truncated_frontmatter, :format_created_at
+      end
+    end
+  end
+end
diff --git a/lib/hive/tui/info_panel_content/stage_reader.rb b/lib/hive/tui/info_panel_content/stage_reader.rb
new file mode 100644
index 00000000..87222fb1
--- /dev/null
+++ b/lib/hive/tui/info_panel_content/stage_reader.rb
@@ -0,0 +1,105 @@
+require "hive/task"
+require "hive/tui/info_panel_content/artifact_reader"
+require "hive/tui/log_tail"
+
+module Hive
+  module Tui
+    module InfoPanelContent
+      # Resolves common logs and stage-specific artifacts for the info panel.
+      module StageReader
+        module_function
+
+        def load_latest_log_path(folder)
+          return [ nil, false ] if folder.empty?
+
+          log_dir = resolve_log_dir(folder)
+          return [ nil, false ] if log_dir.nil?
+
+          path = LogTail::FileResolver.latest(log_dir)
+          [ File.expand_path(path), true ]
+        rescue Hive::NoLogFiles, Hive::InvalidTaskPath, *LogTail::FILESYSTEM_RESCUE
+          [ nil, false ]
+        end
+
+        def load_stage_extra(stage, folder)
+          case stage.to_s
+          when "2-brainstorm"
+            load_markdown_extra(:brainstorm, "brainstorm.md", folder)
+          when "3-plan"
+            load_markdown_extra(:plan, "plan.md", folder)
+          when "4-execute"
+            load_execute_log_extra(folder)
+          else
+            [ nil, nil, "", false, false ]
+          end
+        end
+
+        def resolve_log_dir(folder)
+          Hive::Task.new(folder).log_dir
+        rescue Hive::InvalidTaskPath
+          # Tests and transient snapshots may not match Task's path grammar.
+          match = folder.match(
+            %r{\A(?<root>.+)/\.hive-state/stages/[^/]+/(?<slug>[^/]+)\z}
+          )
+          return nil unless match
+
+          File.join(match[:root], ".hive-state", "logs", match[:slug])
+        end
+
+        def load_markdown_extra(kind, filename, folder)
+          return [ kind, filename, "", false, false ] if folder.empty?
+
+          path = File.join(folder, filename)
+          return [ kind, filename, "", false, false ] unless File.file?(path)
+
+          raw = ArtifactReader.read_bounded_bytes(path, MARKDOWN_BYTE_CAP)
+          return [ kind, filename, "", false, false ] if raw.nil?
+
+          text, trunc = ArtifactReader.bound_text(raw, MARKDOWN_BYTE_CAP)
+          on_disk_trunc = ArtifactReader.file_exceeds_cap?(path, MARKDOWN_BYTE_CAP)
+          [ kind, filename, text, true, trunc || on_disk_trunc ]
+        rescue *LogTail::FILESYSTEM_RESCUE
+          [ kind, filename, "", false, false ]
+        end
+
+        def load_execute_log_extra(folder)
+          label = "execute log"
+          return [ :execute_log, label, "", false, false ] if folder.empty?
+
+          log_dir = resolve_log_dir(folder)
+          return [ :execute_log, label, "", false, false ] if log_dir.nil?
+
+          path = LogTail::FileResolver.latest(log_dir, pattern: EXECUTE_LOG_PATTERN)
+          text, trunc = read_log_tail(path)
+          [ :execute_log, label, text, true, trunc ]
+        rescue Hive::NoLogFiles, Hive::InvalidTaskPath, *LogTail::FILESYSTEM_RESCUE
+          [ :execute_log, label, "", false, false ]
+        end
+
+        def read_log_tail(path)
+          tail = LogTail::Tail.new(
+            path,
+            ring_capacity: EXECUTE_TAIL_LINES + 1,
+            backbuffer_bytes: EXECUTE_BACKBUFFER_BYTES
+          )
+          tail.open!
+          lines = tail.lines(EXECUTE_TAIL_LINES + 1)
+          ring_truncated = lines.length > EXECUTE_TAIL_LINES
+          lines = lines.last(EXECUTE_TAIL_LINES).map do |line|
+            ArtifactReader.scrub_encoding(line)
+          end
+          text = lines.join("\n")
+          backbuffer_truncated = ArtifactReader.file_exceeds_cap?(
+            path, EXECUTE_BACKBUFFER_BYTES
+          )
+          [ text, ring_truncated || backbuffer_truncated ]
+        ensure
+          tail&.close!
+        end
+
+        private_class_method :resolve_log_dir, :load_markdown_extra,
+                             :load_execute_log_extra, :read_log_tail
+      end
+    end
+  end
+end
diff --git a/lib/hive/tui/key_map.rb b/lib/hive/tui/key_map.rb
index 8233e9a4..a9c051e1 100644
--- a/lib/hive/tui/key_map.rb
+++ b/lib/hive/tui/key_map.rb
@@ -402,11 +402,14 @@ module Hive
         Messages::BACK
       end
 
-      # Idea preview is read-only: every key closes it and returns to
-      # grid, whether Bubble Tea emitted a printable String or a
-      # special-key Symbol.
+      # Full-screen info panel is read-only. Only `q`, Esc, and `i`
+      # close it; every other key (including navigation and workflow
+      # verbs) is an explicit no-op so the panel cannot scroll or
+      # dispatch accidentally.
       def idea_preview_message(key:, row:) # rubocop:disable Lint/UnusedMethodArgument
-        Messages::BACK
+        return Messages::BACK if key == "q" || key == :key_escape || key == "i"
+
+        Messages::NOOP
       end
 
       # New-idea prompt mode — same key shape as `:filter` mode but
diff --git a/lib/hive/tui/log_tail.rb b/lib/hive/tui/log_tail.rb
index a997fd5d..535381b9 100644
--- a/lib/hive/tui/log_tail.rb
+++ b/lib/hive/tui/log_tail.rb
@@ -149,26 +149,30 @@ module Hive
       module FileResolver
         module_function
 
-        # Returns the path with the most recent mtime among
-        # `<log_dir>/*.log`. Raises `Hive::NoLogFiles` when the glob
-        # is empty so the render-mode boundary can short-circuit
-        # back to grid with a flash message instead of opening an
-        # empty viewer.
-        def latest(log_dir)
-          latest_in_dirs([ log_dir ])
+        # Returns the path with the most recent mtime among files matching
+        # `pattern` under `<log_dir>` (default `*.log`). Raises
+        # `Hive::NoLogFiles` when the glob is empty so the render-mode
+        # boundary can short-circuit back to grid with a flash message
+        # instead of opening an empty viewer.
+        #
+        # `pattern` is a Dir glob basenames pattern (e.g. `"*.log"`,
+        # `"execute-*.log"`). Callers that do not pass a pattern keep the
+        # historical all-logs behaviour.
+        def latest(log_dir, pattern: "*.log")
+          latest_in_dirs([ log_dir ], pattern: pattern)
         end
 
-        def latest_in_dirs(log_dirs)
+        def latest_in_dirs(log_dirs, pattern: "*.log")
           dirs = Array(log_dirs)
-          candidates = dirs.flat_map { |log_dir| Dir[File.join(log_dir.to_s, "*.log")] }
-          raise Hive::NoLogFiles, "no log files in #{dirs.join(', ')}" if candidates.empty?
+          glob = pattern.to_s.empty? ? "*.log" : pattern.to_s
+          candidates = dirs.flat_map { |log_dir| Dir[File.join(log_dir.to_s, glob)] }
 
-          # `File.mtime` can race with concurrent log rotation that removes a
-          # path between glob and stat; skip the vanished entries rather than
-          # let Errno::ENOENT crash the TUI.
+          # One stat both rejects non-files and supplies mtime. It can race
+          # with log rotation, so invalid/vanished entries are skipped.
           with_mtimes = candidates.filter_map do |path|
-            [ path, File.mtime(path) ]
-          rescue Errno::ENOENT
+            stat = File.stat(path)
+            [ path, stat.mtime ] if stat.file?
+          rescue *FILESYSTEM_RESCUE
             nil
           end
           raise Hive::NoLogFiles, "no log files in #{dirs.join(', ')}" if with_mtimes.empty?
diff --git a/lib/hive/tui/messages.rb b/lib/hive/tui/messages.rb
index 980952a5..bd74d0c2 100644
--- a/lib/hive/tui/messages.rb
+++ b/lib/hive/tui/messages.rb
@@ -179,13 +179,23 @@ module Hive
       # (workflow-contextual) and the verb keys (subprocess dispatch).
       OpenTaskFolder = Data.define(:row)
 
-      # `i` in grid mode — read the focused row's source idea.md and
-      # show its original_text in the bottom strip. Carries the row so
-      # BubbleModel's side-effect handler can resolve `row.folder` at
-      # the moment of the keystroke; this cannot be a payload-free
-      # singleton because snapshot polling may move the live cursor.
+      # `i` in grid mode — open the full-screen task info panel for the
+      # focused row. Carries the row so BubbleModel's side-effect handler
+      # can start a background load of InfoPanelContent at the moment of
+      # the keystroke; this cannot be a payload-free singleton because
+      # snapshot polling may move the live cursor. Internal seam name
+      # remains OpenIdeaPreview / :idea_preview; user-facing copy says
+      # "info".
       OpenIdeaPreview = Data.define(:row)
 
+      # Background load of InfoPanelContent finished successfully.
+      # `token` must match the open panel's request token or Update
+      # ignores the result (user already closed or switched rows).
+      IdeaPreviewLoaded = Data.define(:token, :content)
+
+      # Background load failed. Same token-matching rule as Loaded.
+      IdeaPreviewFailed = Data.define(:token, :error)
+
       # `s` in grid mode — suspend the TUI and open the focused row's
       # configured development agent in the feature worktree. BubbleModel
       # owns the marker flip and the foreground takeover here; the
diff --git a/lib/hive/tui/model.rb b/lib/hive/tui/model.rb
index b81a44c0..5b340531 100644
--- a/lib/hive/tui/model.rb
+++ b/lib/hive/tui/model.rb
@@ -40,8 +40,9 @@ module Hive
       # asset. Resets only on open / cancel / submit.
       :new_idea_attachment_counter,
       :new_idea_broken_labels, # Array<String> — labels highlighted after rich-submit validation fails
-      :idea_preview_text, # String or nil — original_text rendered in :idea_preview mode
-      :idea_preview_slug, # String or nil — slug captured when the preview opened
+      # Model::IdeaPreviewState or nil — full-screen info panel state for
+      # :idea_preview mode (loading/ready/error + request token + content).
+      :idea_preview_state,
       :flash,            # String or nil — current status-line message
       :flash_set_at,     # Time or nil — flash decay timestamp
       :tail_state,       # Hive::Tui::LogTail::Tail or nil — :log_tail mode only
@@ -104,6 +105,35 @@ module Hive
       end
     end
 
+    # Full-screen task info panel (`:idea_preview` mode). Carries the
+    # selected row identity, a unique request token (so late async loads
+    # cannot overwrite a panel the user already closed), status, and the
+    # InfoPanelContent snapshot once ready.
+    Model::IdeaPreviewState = Data.define(
+      :row,
+      :token,
+      :status, # :loading | :ready | :error
+      :content, # Hive::Tui::InfoPanelContent::Content or nil
+      :error_message # String or nil
+    )
+    class Model::IdeaPreviewState
+      def initialize(row:, token:, status: :loading, content: nil, error_message: nil)
+        super
+      end
+
+      def loading?
+        status == :loading
+      end
+
+      def ready?
+        status == :ready
+      end
+
+      def error?
+        status == :error
+      end
+    end
+
     class Model
       # Boot state. App.run constructs the runner with this Model.
       # `pane_focus` defaults to `:right` so the table is the first
@@ -128,8 +158,7 @@ module Hive
           new_idea_staging_tmp_root: nil,
           new_idea_attachment_counter: 0,
           new_idea_broken_labels: [],
-          idea_preview_text: nil,
-          idea_preview_slug: nil,
+          idea_preview_state: nil,
           flash: nil,
           flash_set_at: nil,
           tail_state: nil,
diff --git a/lib/hive/tui/text.rb b/lib/hive/tui/text.rb
index 44b2c791..eca706b0 100644
--- a/lib/hive/tui/text.rb
+++ b/lib/hive/tui/text.rb
@@ -18,10 +18,10 @@ module Hive
       # below via the literal `\e` byte.
       ANSI_CSI_PATTERN = /\e\[[\d;?]*[ -\/]*[@-~]/.freeze
 
-      # 0x00–0x1F C0 + 0x7F DEL. Covers the plain control bytes that
+      # C0, DEL, and C1 control characters. Covers the controls that
       # would corrupt a single-line status flash (most importantly
-      # CR/LF/0x08 which lipgloss does not strip on its own).
-      CONTROL_CHARS_PATTERN = /[\x00-\x1f\x7f]/.freeze
+      # CR/LF/0x08, plus Unicode NEL and terminal C1 sequences).
+      CONTROL_CHARS_PATTERN = /[\u0000-\u001f\u007f-\u009f]/.freeze
 
       module_function
 
@@ -32,7 +32,8 @@ module Hive
       # string — every caller is concerned with display safety, not
       # with surfacing a TypeError on a missing field.
       def sanitize(text)
-        text.to_s.gsub(ANSI_CSI_PATTERN, "").gsub(CONTROL_CHARS_PATTERN, "?")
+        utf8 = text.to_s.dup.force_encoding(Encoding::UTF_8).scrub("?")
+        utf8.gsub(ANSI_CSI_PATTERN, "").gsub(CONTROL_CHARS_PATTERN, "?")
       end
     end
   end
